package sdsi;

import sdsi.sexp.*;

public class KeyHolder extends SDSIObject implements Subject{
  SDSIPrincipal creatingPrincipal;  //may not need to carry this around
  //may only need for creation
  public KeyHolder(SexpList l,SDSIPrincipal p) throws SexpParseException {
    super(l);
    creatingPrincipal = p;
    if (!l.getType().equals("keyholder"))
      throw new SexpParseException("Not a keyholder");
    if (!(l.size() == 2) || !(l.elementAt(1) instanceof SexpList))
      throw new SexpParseException("Incorrectly formatted keyholder");
    SDSIObject supposedHolder = SDSIObject.principalParse((SexpList)l.elementAt(1),creatingPrincipal);
    if (!(supposedHolder instanceof SDSIPrincipal) && !(supposedHolder instanceof Name))
      throw new SexpParseException("Keyholder must be a principal or a name");
  }
  public SDSIObject getObject() {
    try {
      return SDSIObject.principalParse((SexpList)srep.elementAt(1),creatingPrincipal);
    }
    catch (SexpParseException e) {
      return null;
    }
  }
  public String toShortString() {
    return "k_h " + this.getObject().toShortString();
  }
}  
