package sdsi;

import sdsi.sexp.*;

public class ObjectHash extends SDSIObject implements Subject{
  //not actually store the reference to the hash, just return it when necessary
  //is that the best way to go?
  public ObjectHash(SexpList l) throws SexpParseException {
    super(l);
    if (!l.getType().equals("object-hash"))
      throw new SexpParseException("Not a object hash");
    if (!(l.size() == 2) || !(l.elementAt(1) instanceof SexpList))
      throw new SexpParseException("Incorrectly formatted object hash");
    if (!(SDSIObject.principalParse((SexpList)l.elementAt(1),null) instanceof Hash))
      throw new SexpParseException("Object hash must be a hash");
  }
  public Hash getHash(){ //returns null if problem in hash, shouldn't be
    try {
      return (Hash)SDSIObject.principalParse((SexpList)srep.elementAt(1),null);
    }
    catch (SexpParseException e) {
      return null;
    }
  }
  public String toShortString() {
    return "Obj " + this.getHash().toShortString();
  }
}   
