package sdsi;  //should extend SDSIObject????  if not must remove from SexpList.sdsify()

import sdsi.sexp.*;
import java.util.*;

public class Sequence extends SDSIObject {
  
  SDSIObject[] members;
  
  public Sequence(SexpList l) throws SexpParseException{
    super(l); 
    Sexp[] s_members = l.arrayOfElements();
    members = new SDSIObject[s_members.length - 1];
    for (int i = 0;i < members.length; i++) {
      if (s_members[i+1] instanceof SexpList) {
        members[i]=SDSIObject.principalParse((SexpList)s_members[i+1],null);
        if (!(members[i] instanceof Cert) && !(members[i] instanceof SDSIPublicKey)
         && !(members[i] instanceof Op) && !(members[i] instanceof SDSISignature))
          throw new SexpParseException("Sequence should only contain:PublicKeys, Signatures, Certs, and Ops");
      }
      else
        throw new SexpParseException("Incorrect formatted sequence; contains a SexpString");
    }
  }
  public SDSIObject[] members() {
    return members;
  }
  public int count() {
    return members.length;
  }
  public String getType() {
    return "Sequence";
  }
  public String toShortString() {
    return "Sequence: " + members.length + " components";
  }
}
