package sdsi.control;

import java.awt.*;
import java.awt.event.*;

class ErrorDialog extends Dialog implements ActionListener {
    Panel okp;
    Button showDetails;
    Button ok;
    String details;
    Frame parent;
    
    ErrorDialog(Frame frame, String errorType, String errorMesg) {
      super(frame, errorType, true /*modal*/ );
      parent = frame;
      Label mesgLabel = new Label(errorMesg,Label.CENTER);
      mesgLabel.setFont(new Font("Dialog",Font.PLAIN,14));
      add("Center",mesgLabel);
      okp = new Panel();
      okp.setLayout(new FlowLayout());
      ok = new Button("OK");
      ok.addActionListener(this);
      okp.add(ok);
      add("South",okp);
      pack();
      this.addWindowListener(new WindowCloser(this));
      Point p = frame.getLocation();  // why can't i do this any better????
      p.translate(40,100);
      this.setLocation(p);
    }
    ErrorDialog(Frame frame, String errorType, String errorMesg, String details) {
      this(frame,errorType,errorMesg);
      this.details = details;
      showDetails = new Button("Details");
      showDetails.addActionListener(this);
      okp.add(showDetails);
      pack();
    }
    ErrorDialog(Frame frame, String details) {
      super(frame, "Details", true /*modal*/ );
      parent = frame;
      TextArea ta = new TextArea(details);
      add("Center",ta);
      okp = new Panel();
      okp.setLayout(new FlowLayout());
      ok = new Button("OK");
      ok.addActionListener(this);
      okp.add(ok);
      add("South",okp);
      pack();
      this.addWindowListener(new WindowCloser(this));
      Point p = frame.getLocation();  // why can't i do this any better????
      p.translate(40,100);
      this.setLocation(p);
    }
    public void actionPerformed(ActionEvent e) {
      Object object = e.getSource();
      if (object == ok)
        dispose();
      else if (object == showDetails)
        new ErrorDialog(parent, details).setVisible(true);
    }
  }