package sdsi.control;

import sdsi.sexp.*;
import sdsi.*;
import java.awt.*;
import java.awt.event.*;
import java.io.*;
import java.util.*;
import java.security.*;
import java.security.interfaces.*;
import java.math.*;

public class SDSIMainFrame extends Frame{

  CertCache cache;
  Verification verifier;
  SDSIObject current; //do we still need this?

  public static void main(String argv[]) {
    Security.addProvider(new cryptix.provider.Cryptix());
    SDSIMainFrame base = new SDSIMainFrame();
    base.setVisible(true);
    base.identityMenuItem_Action(null);
  }

  public SDSIMainFrame() {
    this.cache = null;
    this.current = null;
    this.verifier = null;
    this.setFont(new Font("Dialog",Font.PLAIN, 14));
  		//{{INIT_CONTROLS
		setLayout(new BorderLayout(0,0));
		setVisible(false); //why is this here
		main = new Panel();
		main.setLayout(new GridBagLayout());
		add("Center",main);
		panelStatus = new Panel();
		panelStatus.setLayout(new FlowLayout(FlowLayout.CENTER,5,5));
		add("North",panelStatus);

		status = new TextField(40);
		status.setEditable(false);
		panelStatus.add(status);

		GridBagConstraints gbc = new GridBagConstraints();
		gbc.weighty = 1.0;
		gbc.gridy = 0;
		gbc.fill = GridBagConstraints.BOTH;

		gbc.gridx = 1;
		gbc.weightx = 0;
		main.add(rightPanel = new Panel(),gbc);
		rightPanel.setLayout(new GridBagLayout());
		controls = new Panel();
		controls.setLayout(cards=new CardLayout());

		panelDisplay = new Panel();
		gbc.gridx = 0;
		gbc.weightx = 1;
		main.add(panelDisplay,gbc);
		panelDisplay.setLayout(new BorderLayout(0,0));
		Label displayLabel = new Label("SDSI Object");
		panelDisplay.add("North",displayLabel);
		display = new TextArea("",16,50,TextArea.SCROLLBARS_VERTICAL_ONLY);
		display.setFont(new Font("Monospaced",Font.PLAIN, 14));
		display.setEditable(false);
		panelDisplay.add("Center", display);

		panelObjList = new Panel();
		gbc.gridy = 0;
		gbc.weighty = 1;
		rightPanel.add(panelObjList,gbc);
		gbc.gridy = 1;
		gbc.weighty = 0;
		rightPanel.add(controls,gbc);
		panelObjList.setLayout(new BorderLayout(0,0));
		Label objListLabel = new Label("Current Objects");
		panelObjList.add("North", objListLabel);
		objectList = new List(10,false);
		panelObjList.add("Center", objectList);

		panelObjects = new Panel();
	  controls.add(SDSIOBJECTS,panelObjects);
	  panelObjects.setLayout(new FlowLayout());
	  newObject = new TextArea(8,24);
	  panelObjects.add(newObject);
	  createObject = new Button("Create Object");
	  panelObjects.add(createObject);

	  panelIdentity = new Panel();
	  controls.add(IDENTITY,panelIdentity);
	  panelIdentity.setLayout(new BorderLayout());
	  panelIdentity.add("Center",panelITop = new Panel());
	  panelITop.setLayout(new FlowLayout());
	  panelFiles = new Panel();
	  panelITop.add(panelFiles);
	  panelFiles.setLayout(new GridLayout(6,1));
	  panelFiles.add(new Label("Public Key"));
	  file1 = new TextField(25);
	  panelFiles.add(file1);
	  chooseFile1 = new Button("Choose File");
	  panelFiles.add(chooseFile1);
	  panelFiles.add(new Label("Private Key"));
	  file2 = new TextField(25);
	  panelFiles.add(file2);
	  chooseFile2 = new Button("Choose File");
	  panelFiles.add(chooseFile2);
	  generateIdentity = new Button("Generate Identity");
	  panelITop.add(generateIdentity);
	  panelIdentity.add("South",panelIBottom = new Panel());
	  panelIBottom.setLayout(new FlowLayout());
	  panelIBottom.add(loadCache = new Button("Load Cache from File"));

    panelVerify = new Panel();
    controls.add(VERIFY,panelVerify);
    panelVerify.setLayout(new GridLayout(5,1));
    panelVerify.add(vAclPanel = new Panel());
    vAclPanel.setLayout(new FlowLayout());
    vAclPanel.add(vChooseAcl = new Button("Choose Acl"));
    vAclPanel.add(vShowAcl = new TextField(20));
    panelVerify.add(vSequencePanel = new Panel());
    vSequencePanel.setLayout(new FlowLayout());
    vSequencePanel.add(vChooseSequence = new Button("Choose Sequence"));
    vSequencePanel.add(vShowSequence = new TextField(20));
    panelVerify.add(vRequestPanel = new Panel());
    vRequestPanel.setLayout(new FlowLayout());
    vRequestPanel.add(vChooseRequest = new Button("Choose Request"));
    vRequestPanel.add(vShowRequest = new TextField(20));
    panelVerify.add(vSignaturePanel = new Panel());
    vSignaturePanel.setLayout(new FlowLayout());
    vSignaturePanel.add(vChooseSignature = new Button("Choose Signature"));
    vSignaturePanel.add(vShowSignature = new TextField(20));
    panelVerify.add(vButtonPanel = new Panel());
    vButtonPanel.setLayout(new FlowLayout());
    vButtonPanel.add(verifySequence = new Button("Verify Sequence"));
    vShowSequence.setEditable(false);
    vShowAcl.setEditable(false);
    vShowSignature.setEditable(false);
    vShowRequest.setEditable(false);

    panelCerts = new Panel();
    controls.add(CERTS,panelCerts);
    panelCerts.setLayout(new GridLayout(3,1));
    panelCerts.add(topPanel = new Panel());
    panelCerts.add(panelCommon = new Panel());
    panelCerts.add(panelCommon2 = new Panel());
    topPanel.setLayout(cards);

    panelNames = new Panel();
    topPanel.add(DEFS,panelNames);
    panelNames.setLayout(new GridLayout(2,1));
    panelNames.add(buttonPanel = new Panel());
    buttonPanel.setLayout(new FlowLayout(FlowLayout.LEFT));
    buttonPanel.add(new Label("Create a new Name Definition Cert"));
    buttonPanel.add(createName = new Button("Create Name"));
    panelNames.add(namePanel = new Panel());
    namePanel.setLayout(new FlowLayout(FlowLayout.LEFT));
    namePanel.add(new Label("Name to Define"));
    namePanel.add(nameShown = new TextField(25));

    topPanel.add(AUTHS,panelAuths = new Panel());
    panelAuths.setLayout(new GridLayout(2,1));
    panelAuths.add(authPanel = new Panel());
    authPanel.setLayout(new FlowLayout(FlowLayout.LEFT));
    authPanel.add(new Label("Create a new Authorization Cert"));
    authPanel.add(createAuth = new Button("Create Auth"));
    panelAuths.add(authPanel2 = new Panel());
    authPanel2.setLayout(new FlowLayout(FlowLayout.LEFT));
    authPanel2.add(new Label("(tag"));
    authPanel2.add(tagField = new TextField(20));
    authPanel2.add(new Label(")"));
    authPanel2.add(propagate = new Checkbox("Propagate"));

    panelCommon.setLayout(new GridLayout(2,1));
    panelCommon.add(subjectPanel = new Panel());
    subjectPanel.setLayout(new FlowLayout(FlowLayout.LEFT));
    subjectPanel.add(new Label("      Subject:"));
    panelCommon.add(subjectPanel2 = new Panel());
    subjectPanel2.setLayout(new FlowLayout(FlowLayout.LEFT));
    subjectPanel2.add(subjectChoices = new Choice());
    subjectChoices.addItem("Double-Click");
    subjectChoices.addItem("Type a Name");
    subjectPanel2.add(new Label("  YYYY-MM-DD_HH:MM:SS"));

    panelCommon2.setLayout(new GridLayout(2,1));
    panelCommon2.add(beforePanel = new Panel());
    beforePanel.setLayout(new FlowLayout(FlowLayout.LEFT));
    beforePanel.add(new Label("Not before:    "));
    beforePanel.add(beforeField = new TextField(19));
    panelCommon2.add(afterPanel = new Panel());
    afterPanel.setLayout(new FlowLayout(FlowLayout.LEFT));
    afterPanel.add(new Label("   Not after:    "));
    afterPanel.add(afterField = new TextField(19));


		setTitle("SDSI Certificate Utility");
		//}}
		subjectPanel.add(subjectShown = new SubjectField(25));
		pack();
		//{{INIT_MENUS
		SDSIMainMenuBar = new MenuBar();
		
		SDSIMainMenuBar.add(fileMenu = new Menu("File"));
		fileMenu.add(readFileMenuItem = new MenuItem("Read File"));
		fileMenu.add(saveSexpMenuItem = new MenuItem("Save S-expression"));
		fileMenu.add(identityMenuItem = new MenuItem("Load Identity"));
		fileMenu.add(saveCacheMenuItem = new MenuItem("Save Cache"));
		fileMenu.add(quitMenuItem = new MenuItem("Quit"));
		
		SDSIMainMenuBar.add(viewMenu = new Menu("View"));
		viewMenu.add(curObjMenuItem = new MenuItem("Current Objects"));
		viewMenu.add(viewAuthsMenuItem = new MenuItem("Authorization Certs"));
		viewMenu.add(viewDefsMenuItem = new MenuItem("Name Definition Certs"));
		viewMenu.add(viewKeysMenuItem = new MenuItem("Public Keys"));
		
		SDSIMainMenuBar.add(objectMenu = new Menu("Object"));
		objectMenu.add(createObjectMenuItem = new MenuItem("Create"));
		objectMenu.add(hashObjectMenu = new Menu("Hash"));
		hashObjectMenu.add(md5HOMI = new MenuItem("MD5"));
		hashObjectMenu.add(sha1HOMI = new MenuItem("SHA-1"));
		objectMenu.add(signaturesMenuItem = new MenuItem("Sign"));
		objectMenu.add(removeObjectMenuItem = new MenuItem("Remove"));
		
		certMenu = new Menu("Certificates");
		defMenuItem = new MenuItem("Name Definitions");
		certMenu.add(defMenuItem);
		certMenu.add(authMenuItem = new MenuItem("Authorizations"));
		SDSIMainMenuBar.add(certMenu);
		keyMenu = new Menu("Keys");
		generateKeyPairMenuItem = new MenuItem("Generate RSA Key Pair");
		keyMenu.add(generateKeyPairMenuItem);
		SDSIMainMenuBar.add(keyMenu);
		verifyMenu = new Menu("Verify");
		verifySequenceMenuItem = new MenuItem("Verify a Sequence");
		verifyMenu.add(verifySequenceMenuItem);
		SDSIMainMenuBar.add(verifyMenu);
		setMenuBar(SDSIMainMenuBar);
		//}}


		//{{REGISTER_LISTENERS
		SymAction lSymAction = new SymAction();
		readFileMenuItem.addActionListener(lSymAction);
		curObjMenuItem.addActionListener(lSymAction);
		SymItem lSymItem = new SymItem();
		objectList.addItemListener(lSymItem);
		SymComponent aSymComponent = new SymComponent();
		this.addComponentListener(aSymComponent);
		signaturesMenuItem.addActionListener(lSymAction);
		createObject.addActionListener(lSymAction);
		generateKeyPairMenuItem.addActionListener(lSymAction);
		saveSexpMenuItem.addActionListener(lSymAction);
		quitMenuItem.addActionListener(lSymAction);
		chooseFile1.addActionListener(lSymAction);
		chooseFile2.addActionListener(lSymAction);
		generateIdentity.addActionListener(lSymAction);
		identityMenuItem.addActionListener(lSymAction);
		defMenuItem.addActionListener(lSymAction);
		subjectChoices.addItemListener(lSymItem);
		objectList.addActionListener(lSymAction);
		createName.addActionListener(lSymAction);
		authMenuItem.addActionListener(lSymAction);
		createAuth.addActionListener(lSymAction);
		verifySequenceMenuItem.addActionListener(lSymAction);
		vChooseAcl.addActionListener(lSymAction);
		vChooseSequence.addActionListener(lSymAction);
		vChooseRequest.addActionListener(lSymAction);
		vChooseSignature.addActionListener(lSymAction);
		verifySequence.addActionListener(lSymAction);
		md5HOMI.addActionListener(lSymAction);
		sha1HOMI.addActionListener(lSymAction);
		removeObjectMenuItem.addActionListener(lSymAction);
		viewAuthsMenuItem.addActionListener(lSymAction);
		viewDefsMenuItem.addActionListener(lSymAction);
		viewKeysMenuItem.addActionListener(lSymAction);
		saveCacheMenuItem.addActionListener(lSymAction);
		loadCache.addActionListener(lSymAction);
		createObjectMenuItem.addActionListener(lSymAction);
		//}}
		this.addWindowListener(new WindowCloser(this));
	}


	//{{DECLARE_CONTROLS
	static final String SDSIOBJECTS = "SDSI Objects";
	static final String IDENTITY = "Identity";
  static final String SIGNATURES = "Signatures";
  static final String CERTS = "Certificates";
  static final String DEFS = "Name Definitions";
  static final String AUTHS = "Authorizations";
  static final String VERIFY = "Verify";

	Panel panelStatus;
	TextField status;

	Panel main;
	Panel rightPanel;
	Panel panelDisplay;
	TextArea display;
	Panel panelObjList;
	List objectList;

	Panel controls;
	CardLayout cards;

	Panel panelObjects;
	TextArea newObject;
	Button createObject;

	Panel panelIdentity;
	Panel panelITop;
	Panel panelFiles;
	Button chooseFile1;
	Button chooseFile2;
	TextField file1;
	TextField file2;
	Button generateIdentity;
	Panel panelIBottom;
	Button loadCache;

	Panel panelVerify;
	Panel vAclPanel;
	Button vChooseAcl;
	TextField vShowAcl;
	Panel vSequencePanel;
	Button vChooseSequence;
	TextField vShowSequence;
	Panel vRequestPanel;
	Button vChooseRequest;
	TextField vShowRequest;
	Panel vSignaturePanel;
	Button vChooseSignature;
	TextField vShowSignature;
	Panel vButtonPanel;
	Button verifySequence;

	Panel panelCerts;
	Panel topPanel;

	Panel panelNames;
	Panel buttonPanel;
  Button createName;
	Panel namePanel;
	TextField nameShown;

	Panel panelAuths;
	Button createAuth;
	Panel authPanel;
	Panel authPanel2;
	TextField tagField;
	Checkbox propagate;

	Panel panelCommon;
	Panel panelCommon2;
	Panel subjectPanel;
	Panel subjectPanel2;
	Choice subjectChoices;
	Panel beforePanel;
	Panel afterPanel;
	TextField beforeField;
	TextField afterField;


	//}}
	SubjectField subjectShown;
	//{{DECLARE_MENUS
	MenuBar SDSIMainMenuBar;
	Menu fileMenu;
	MenuItem readFileMenuItem;
	MenuItem saveSexpMenuItem;
	MenuItem identityMenuItem;
	MenuItem saveCacheMenuItem;
	MenuItem quitMenuItem;
	Menu viewMenu;
	MenuItem curObjMenuItem;
	MenuItem viewDefsMenuItem;
	MenuItem viewAuthsMenuItem;
	MenuItem viewKeysMenuItem;
	Menu objectMenu;
	MenuItem createObjectMenuItem;
	Menu hashObjectMenu;
	MenuItem md5HOMI;
	MenuItem sha1HOMI;
	MenuItem signaturesMenuItem;
	MenuItem removeObjectMenuItem;
	Menu certMenu;
	MenuItem defMenuItem;
	MenuItem authMenuItem;
	Menu keyMenu;
	MenuItem generateKeyPairMenuItem;
	Menu verifyMenu;
	MenuItem verifySequenceMenuItem;
	//}}
  public void readFile() {
    FileDialog fd = new FileDialog(this,"Read in S-Expressions",FileDialog.LOAD);
    fd.setDirectory("c:\\sdsi\\"); //don't want this in final version
    fd.setVisible(true);
    String file = fd.getDirectory() + fd.getFile();
    int countSexps = 0;
    if (file == null)
      return;
    try {
      FileInputStream fis = new FileInputStream(file);
      PushbackInputStream pbis = new PushbackInputStream(fis);
      while (processStream(pbis,true) != null) {
        countSexps++;
      }
      fis.close();
    }
    catch (IOException e) {
      status.setText(e.getMessage());
    }
    status.setText(countSexps + " S-expressions parsed");
  }

	SDSIObject processStream(PushbackInputStream pbis, boolean add) {
	  try {
	    Sexp test = Sexp.parse(pbis);
	    if (test == null)
	      return null;
	    if (test instanceof SexpList) {
        SexpList l = (SexpList)test;
        SDSIObject example;
        if (cache == null) {
          example = SDSIObject.principalParse(l,null);
        }
        else {
          example = SDSIObject.principalParse(l,cache.getOwner());
          if (add) {
            cache.add(example);
          }
        }
        return example;
      }
      else {
        status.setText("Byte-string ignored"); //probably need to fix this
        return null;
      }
    }
    catch (SexpException e) {
      new ErrorDialog(this,"Invalid S-expression",e.getMessage()).setVisible(true);
      return null;
    }
    catch (SexpParseException e){
      new ErrorDialog(this,"Invalid SDSI Object",e.getMessage(),e.getSexp().toReadableString(0,30,0)).setVisible(true);
      return null;
    }
  }

  class SubjectField extends TextField {
    private Subject subj;
    SubjectField(int k) {
      super(k);
      subj = null;
      this.setText("Please select a subject");
      this.setEditable(false);
    }
    Subject getSubject() throws SDSIException {
      if (subjectChoices.getSelectedItem().equals("Type a Name")) {
        try {
          if (this.getText().equals(""))
            throw new SDSIException("Need a name");
          StringBuffer name = new StringBuffer("(name ");
          name.append(cache.getOwner().toString() + " ");
          name.append(this.getText() + ")");
          PushbackInputStream p = new PushbackInputStream(new ByteArrayInputStream(name.toString().getBytes("8859_1")));
    	    Name n = (Name)processStream(p,false);
    	    return n;
    	  }
    	  catch (UnsupportedEncodingException e) {
    	    return null; //won't happen
        }
      }
      else
        return subj;
    }
    void setSubject(Subject s) {
      subj = s;
    }
  }

	class SymAction implements ActionListener
	{
		public void actionPerformed(ActionEvent event)
		{
		  status.setText("");
			Object object = event.getSource();
			if (object == generateKeyPairMenuItem)
				generateKeyPairMenuItem_Action(event);
			else if (object == chooseFile1)
				chooseFile1_Action(event);
			else if (object == chooseFile2)
				chooseFile2_Action(event);
			else if (object == generateIdentity)
				generateIdentity_Action(event);
			else if (object == identityMenuItem)
				identityMenuItem_Action(event);
			else if (object == saveSexpMenuItem)
				saveSexpMenuItem_Action(event,"S-expression");
			else if (object == quitMenuItem)
				quitMenuItem_Action(event);
			else if (object == loadCache)
				loadCache_Action(event);
		  else if (cache == null) {
			  new ErrorDialog(SDSIMainFrame.this,"Initialization Error","Please Load an Identity first").setVisible(true);
			  return;
			}
			else if (object == curObjMenuItem)
				curObjMenuItem_Action(event);
			else if (object == signaturesMenuItem)
				signaturesMenuItem_Action(event);
			else if (object == createObject)
				createObject_Action(event);
			else if (object == readFileMenuItem)
				readFileMenuItem_Action(event);
			else if (object == defMenuItem)
				defMenuItem_Action(event);
			else if (object == objectList)
				objectList_DblClicked(event);
			else if (object == createName)
				createName_Action(event);
			else if (object == authMenuItem)
				authMenuItem_Action(event);
			else if (object == createAuth)
				createAuth_Action(event);
			else if (object == verifySequenceMenuItem)
				verifySequenceMenuItem_Action(event);
			else if (object == vChooseAcl)
				vChooseAcl_Action(event);
			else if (object == vChooseSequence)
				vChooseSequence_Action(event);
			else if (object == vChooseRequest)
				vChooseRequest_Action(event);
			else if (object == vChooseSignature)
				vChooseSignature_Action(event);
			else if (object == verifySequence)
				verifySequence_Action(event);
			else if (object == md5HOMI)
				hashObjectMI_Action(event,"md5");
			else if (object == sha1HOMI)
				hashObjectMI_Action(event,"sha1");
			else if (object == removeObjectMenuItem)
				removeObjectMenuItem_Action(event);
			else if (object == viewAuthsMenuItem)
				viewAuthsMenuItem_Action(event);
			else if (object == viewDefsMenuItem)
				viewDefsMenuItem_Action(event);
			else if (object == viewKeysMenuItem)
				viewKeysMenuItem_Action(event);
			else if (object == saveCacheMenuItem)
				saveCacheMenuItem_Action(event);
			else if (object == createObjectMenuItem)
				createObjectMenuItem_Action(event);
	  }
	}

	void readFileMenuItem_Action(ActionEvent event)
	{
		readFile();
		listCurrentClass(SDSIObject.class);
	}

	void listCurrentClass(Class c) {
	  Object curKey;
    objectList.removeAll();
    cache.setDisplay(c);
    for (Enumeration names = cache.getDisplayedNames();names.hasMoreElements();) {
      objectList.add((String)names.nextElement());
    }
	}

	void curObjMenuItem_Action(ActionEvent event)
	{
		listCurrentClass(SDSIObject.class);
	}

	class SymItem implements ItemListener
	{
		public void itemStateChanged(ItemEvent event)
		{
			Object object = event.getSource();
			if (object == objectList)
				objectList_ItemStateChanged(event);
			else if (object == subjectChoices)
				subjectChoices_ItemStateChanged(event);
	  }
	}

	void objectList_ItemStateChanged(ItemEvent event)
	{
	  String itemChosen = objectList.getSelectedItem();
		SDSIObject obj = (SDSIObject)cache.select(itemChosen);
		status.setText(obj.getType());
	  display.setText(obj.toReadableString(display.getColumns()));
	  current = obj;
	}

	class SymComponent extends ComponentAdapter
	{
		public void componentResized(ComponentEvent event)
		{
			Object object = event.getSource();
			if (object == SDSIMainFrame.this)
				SDSIMainFrame_ComponentResized(event);
		}
	}

	void SDSIMainFrame_ComponentResized(ComponentEvent event)
	{ //this may be machine specific don't know how to do this correctly?
		Dimension d = display.getSize();
		FontMetrics f = display.getFontMetrics(display.getFont());
		int w = f.charWidth('W');
		int h = f.getHeight();
		int num;
		num = d.width/w - 6; //-6 for the scroll bar, just a guess
		if (num < 1)
		  num = 1;
		display.setColumns(num);
		num = d.height/h;
		if (num < 1)
		  num = 1;
		display.setRows(num);
	}

	void signaturesMenuItem_Action(ActionEvent event)
	{
		if (cache.getOwner() != null) {
		  ConfirmDialog query = new ConfirmDialog(this, "Sign Object?");
		  query.setVisible(true);
		  if (query.answer() == true)
		    signObject();
		}
		else
		  new ErrorDialog(this,"Identity Error", "Must Set Identity before Signing").setVisible(true);
	}

	void createObject_Action(ActionEvent event)
	{
	  String newString = newObject.getText();
	  try {
	    PushbackInputStream p = new PushbackInputStream(new ByteArrayInputStream(newString.getBytes("8859_1")));
  	  if (processStream(p,true) != null) {
  	   listCurrentClass(SDSIObject.class);
	    	status.setText("1 S-expression parsed");
	     newObject.setText("");
	    }
	  }
  	catch (UnsupportedEncodingException e) {
  	  new ErrorDialog(this,"Fatal Error",e.getMessage()).setVisible(true);
  	}
	}

	void generateKeyPairMenuItem_Action(ActionEvent event)
	{
	  try {
	    status.setText("Please Wait");
		  KeyPairGenerator kpg = KeyPairGenerator.getInstance("RSA");
		  ((RSAKeyPairGenerator)kpg).initialize(1024,new BigInteger("10001",16),new SecureRandom());
		  KeyPair kp = kpg.generateKeyPair();
		  PublicKey pubKey = kp.getPublic();
		  PrivateKey privKey = kp.getPrivate();
		  SDSIRSAPrivateKey sdsiPrivKey = new SDSIRSAPrivateKey((RSAPrivateKey)privKey);
		  SDSIRSAPublicKey sdsiPubKey = new SDSIRSAPublicKey((RSAPublicKey)pubKey);
		  current = sdsiPrivKey;
		  display.setText(current.toReadableString(display.getColumns()));
		  saveSexpMenuItem_Action(null,"Private Key");
      current = sdsiPubKey;
      display.setText(current.toReadableString(display.getColumns()));
      saveSexpMenuItem_Action(null,"Public Key");
	  }
	  catch (NoSuchAlgorithmException e) {
	    ErrorDialog ed = new ErrorDialog(this,"No Provider",e.getMessage());
	    ed.setVisible(true);
	  }
	}

	void saveSexpMenuItem_Action(ActionEvent event, String saveType)
	{
	  if (current == null) {
	    status.setText("No S-expression displayed");
	    return;
	  }
		FileDialog fd = new FileDialog(this,"Save " + saveType,FileDialog.SAVE);
    fd.setDirectory("c:\\sdsi\\"); //don't want this in final version
    fd.setVisible(true);
    String file = fd.getDirectory() + fd.getFile();
    if (file == null)
      return;
    try {
      FileOutputStream fos = new FileOutputStream(file);
      fos.write(current.toReadableString(72).getBytes("8859_1"));
      fos.close();
      status.setText(saveType + " saved");
    }
    catch (IOException e) {
      new ErrorDialog(this,"I/O Error",e.getMessage()).setVisible(true);
    }
	}

	void quitMenuItem_Action(ActionEvent event)
	{
		this.dispose();
		System.exit(0);
	}

	void chooseFile1_Action(ActionEvent event)
	{
		FileDialog fd = new FileDialog(this,"Choose Public Key",FileDialog.LOAD);
    fd.setDirectory("c:\\sdsi\\"); //don't want this in final version
    fd.setVisible(true);
    String file = fd.getDirectory() + fd.getFile();
    if (fd.getFile() != null)
    file1.setText(file);
	}

	void chooseFile2_Action(ActionEvent event)
	{
		FileDialog fd = new FileDialog(this,"Choose Private Key",FileDialog.LOAD);
    fd.setDirectory("c:\\sdsi\\"); //don't want this in final version
    fd.setVisible(true);
    String file = fd.getDirectory() + fd.getFile();
    if (fd.getFile() != null)
      file2.setText(file);
	}

	void generateIdentity_Action(ActionEvent event)
	{
		String f1 = file1.getText();
		String f2 = file2.getText();
		if (f1.equals("") || f2.equals("")) {
		  new ErrorDialog(this,"File Error","Please specify both a Public Key and a Private Key").setVisible(true);
		  return;
		}
		try {
		  PushbackInputStream p = new PushbackInputStream(new FileInputStream(f1));
		  SDSIObject o = processStream(p,false);
		  SDSIPublicKey pub_key;
		  SDSIPrivateKey priv_key;
		  if (o != null && o instanceof SDSIPublicKey )
		    pub_key = (SDSIPublicKey) o;
		  else {
		    new ErrorDialog(this,"SDSIObject Error","Public key file must contain a public key").setVisible(true);
		    //take out the object used to be here
		    return;
		  }
		  p = new PushbackInputStream(new FileInputStream(f2));
		  o = processStream(p,false);
		  if (o == null) {
		    new ErrorDialog(this,"SDSIObject Error","Private key file must contain a private key").setVisible(true);
		    return;
		  }
		  if (o instanceof SDSIPrivateKey) {
		    priv_key = (SDSIPrivateKey) o;
		    Signature sign = Signature.getInstance("MD5/RSA");
		    Signature verify = Signature.getInstance("MD5/RSA");
        sign.initSign(priv_key);
        verify.initVerify(pub_key);
        byte[] test = new String("Babbaloo Babbaloo Hey How About You?").getBytes();
        sign.update(test);
        verify.update(test);
        if (verify.verify(sign.sign())) {
          cache = new CertCache(pub_key,priv_key);
          cache.add(pub_key);
          verifier = new Verification(cache);
        }
        else
          new ErrorDialog(this,"Identity Error","Public Key and Private Key do not match").setVisible(true);
		  }
		  else {
		    new ErrorDialog(this,"SDSIObject Error","Private key file must contain a private key").setVisible(true);
		    return;
		  }
		  status.setText("Identity set");
		}
    catch (IOException e) {
      new ErrorDialog(this,"I/O Error",e.getMessage()).setVisible(true);
    }
    catch (NoSuchAlgorithmException e) {
      new ErrorDialog(this,"Missing algorithm",e.getMessage()).setVisible(true);
    }
    catch (Exception e){
      new ErrorDialog(this,"Fatal Error",e.getMessage());
    }
	}

	void identityMenuItem_Action(ActionEvent event)
	{
		cards.show(controls,IDENTITY);
	}

	void defMenuItem_Action(ActionEvent event)
	{
	  if (cache.getOwner() != null) {
		  cards.show(controls,CERTS);
		  cards.show(topPanel,DEFS);
		}
		else
		  new ErrorDialog(this,"Identity Error","Must set Identity before you can generate certs").setVisible(true);
	}


	void subjectChoices_ItemStateChanged(ItemEvent event)
	{
		String choiceMethod = (String)event.getItem();
		if (choiceMethod.equals("Type a Name")) {
		  subjectShown.setText("");
		  subjectShown.setEditable(true);
		}
		else {
		  subjectShown.setText("Please Select a Subject");
		  subjectShown.setEditable(false);
		}
	}

	void objectList_DblClicked(ActionEvent event)
	{
	  String itemChosen = objectList.getSelectedItem();
	  status.setText(itemChosen);
		SDSIObject obj = cache.select(itemChosen);
		display.setText(obj.toReadableString(display.getColumns()));
	  current = obj;
		if (panelCerts.isVisible() && subjectChoices.getSelectedItem().equals("Double-Click")) {
		  if (obj instanceof Def) {
		    obj = ((Def)obj).getName();
		  }
	    else if (!(obj instanceof Subject)) {
	      new ErrorDialog(this,"Invalid Choice","Please choose an object that can be a subject").setVisible(true);
	      return;
	    }
	    subjectShown.setSubject((Subject)obj);
	    subjectShown.setText(itemChosen);
	  }
	  else if(panelVerify.isVisible()) {
	    if (obj instanceof Acl) {
	      vShowAcl.setText(itemChosen);
	      verifier.initializeAcl((Acl)obj);
	    }
	    else if (obj instanceof Sequence) {
	      vShowSequence.setText(itemChosen);
	      verifier.setSequence((Sequence)obj);
	    }
	    else if (obj instanceof SDSISignature) {
	      vShowSignature.setText(itemChosen);
	      verifier.setSignature((SDSISignature)obj);
	    }
	    else if (obj instanceof Tag) {
	      vShowRequest.setText(itemChosen);
	      verifier.setRequest((Tag)obj);
	    }
	  }
	}

	void createName_Action(ActionEvent event)
	{
	  try {
		  Subject s = subjectShown.getSubject();
		  Validity v = new Validity();
		  String name = nameShown.getText();
		  if (name.equals("")) {
		    new ErrorDialog(this,"","Must add at least one name").setVisible(true);
		    return;
		  }
		  v.updateStrings(beforeField.getText(),afterField.getText());
		  Def newDef = new Def(cache.getOwner(),name,s,v);
      cache.add(newDef);
      listCurrentClass(Def.class);
      status.setText(newDef.getType());
  	  display.setText(newDef.toReadableString(display.getColumns()));
  	  current = newDef;
      //subjectChoices.select("Show Names");
      signaturesMenuItem_Action(null);
    }
		catch (SDSIException e) {
		  new ErrorDialog(this,"Creation Error",e.getMessage()).setVisible(true);
		  return;
		}
		catch (java.text.ParseException e) {
		  new ErrorDialog(this,"Date Error",e.getMessage()).setVisible(true);
		  return;
		}
	}

	void authMenuItem_Action(ActionEvent event)
	{
		if (cache.getOwner() != null) {
		  cards.show(controls,CERTS);
		  cards.show(topPanel,AUTHS);
		}
		else
		  new ErrorDialog(this,"Identity Error","Must set Identity before you can generate certs").setVisible(true);
	}

  Tag processTag() {
   	Sexp[] majorTagParts = new Sexp[2];
		majorTagParts[0] = new SexpString("tag");
		try {
		    String newTag = tagField.getText();
	      PushbackInputStream p = new PushbackInputStream(new ByteArrayInputStream(newTag.getBytes("8859_1")));
  	    majorTagParts[1] = Sexp.parse(p);
  	    SexpList tagList = new SexpList(majorTagParts);
		    return new Tag(tagList);
		}
		catch (UnsupportedEncodingException e) {
  	  new ErrorDialog(this,"Fatal Error",e.getMessage()).setVisible(true);
  	}
  	catch (SexpParseException e) {
  	  new ErrorDialog(this,"Tag Error",e.getMessage()).setVisible(true);
  	}
		catch (SexpException e) {
		  new ErrorDialog(this,"Tag Error",e.getMessage()).setVisible(true);
		}
		return null;
  }

	void createAuth_Action(ActionEvent event)
	{
	  try {
  		Subject s = subjectShown.getSubject();
  		Validity v = new Validity();
  		boolean prop = propagate.getState();
  		Tag t = processTag();
  		if (t == null || s == null) {
  		  new ErrorDialog(this,"Insufficient Info","Please specify both a subject and a tag").setVisible(true);
  		  return;
  		}
  		v.updateStrings(beforeField.getText(),afterField.getText());
  		Auth newAuth = new Auth(cache.getOwner(),s,t,prop,v);
      cache.add(newAuth);
      listCurrentClass(Auth.class);
      status.setText(newAuth.getType());
  	  display.setText(newAuth.toReadableString(display.getColumns()));
  	  current = newAuth;
      //subjectChoices.select("Show Objects");
      signaturesMenuItem_Action(null);
    }
    catch (SDSIException e) {
		  new ErrorDialog(this,"Creation Error",e.getMessage()).setVisible(true);
		  return;
		}
    catch (java.text.ParseException e) {
		  new ErrorDialog(this,"Date Error",e.getMessage()).setVisible(true);
		  return;
		}
	}

	void signObject()
	{
	  try {
	    if (current == null) {
	      new ErrorDialog(this,"No Object","Please select an object to sign").setVisible(true);
	      return;
	    }
		  SDSISignature newSig = new SDSISignature(current,cache.getOwnerPrivate(),cache.getOwner());
      if (current instanceof Cert) {
        if (cache.getOwner().sameKeyAs(((Cert)current).getIssuer())) {
          cache.add((Cert)current,newSig);
          cache.removeMisc(current);
        }
      }
      listCurrentClass(SDSIObject.class);
      status.setText(current.getType() + " w/ Sig");
	    display.append("\n" + newSig.toReadableString(display.getColumns()));
	  }
	  catch (SignatureException e) {
	    new ErrorDialog(this,"Signature Error",e.getMessage()).setVisible(true);
	  }
	}

	void verifySequenceMenuItem_Action(ActionEvent event)
	{
	  cards.show(controls,VERIFY);
	}

	void vChooseAcl_Action(ActionEvent event)
	{
		listCurrentClass(Acl.class);
	}

	void vChooseSequence_Action(ActionEvent event)
	{
		listCurrentClass(Sequence.class);
	}

	void vChooseRequest_Action(ActionEvent event)
	{
		listCurrentClass(Tag.class);
	}

	void vChooseSignature_Action(ActionEvent event)
	{
		listCurrentClass(SDSISignature.class);
	}

	void verifySequence_Action(ActionEvent event) { 
	  try {
	    String allowed;
	    allowed = verifier.verifyAuthority();
	    display.setText(verifier.getReduction(display.getColumns()));
      status.setText(allowed);
	  }
	  catch (ClassCastException e) {
	    new ErrorDialog(this,"Wrong SDSIObject type",e.getMessage()).setVisible(true);
	    return;
	  }
	  catch (VerificationException e) {
	    new ErrorDialog(this,"Verification did not complete",e.getMessage()).setVisible(true);
	    status.setText("The request is DENIED!");
	    return;
	  }
	}

	void hashObjectMI_Action(ActionEvent event, String alg)
	{ 
	  try {
	    if (current == null) {
	      new ErrorDialog(this,"No Object","Please select an object to hash").setVisible(true);
	      return;
	    }
      ConfirmDialog query = new ConfirmDialog(this, "Hash Object?");
	    query.setVisible(true);
	    if (query.answer() == true) {
		    Hash h = new Hash(alg,current);
		    if (cache.getOwner() != null) 
		      cache.add(h);
		    status.setText("Hash of " + current.getType());  
		    display.setText(h.toReadableString(display.getColumns()));
		  }
		}
		catch (NoSuchAlgorithmException e) {
		  new ErrorDialog(this,"Fatal Error","Can't find hash algorithm");
		  return;
		}
	}

	void removeObjectMenuItem_Action(ActionEvent event)
	{
	   if (current == null) {
	      new ErrorDialog(this,"No Object","Please select an object to remove from cache").setVisible(true);
	      return;
	    } 
		if (cache.getOwner() != null) {
		  ConfirmDialog query = new ConfirmDialog(this, "Remove Object?");
		  query.setVisible(true);
		  if (query.answer() == true) {
		    cache.removeAll(current);
		    status.setText(current.getType() + " removed");
		  }   
		}
		else
		  new ErrorDialog(this,"Identity Error", "Must Have Cache to Remove object").setVisible(true);
	}

	void viewAuthsMenuItem_Action(ActionEvent event)
	{
		listCurrentClass(Auth.class);
	}

	void viewDefsMenuItem_Action(ActionEvent event)
	{
		listCurrentClass(Def.class);
	}

	void viewKeysMenuItem_Action(ActionEvent event)
	{
		listCurrentClass(SDSIPublicKey.class);
	}

	void saveCacheMenuItem_Action(java.awt.event.ActionEvent event)
	{
		FileDialog fd = new FileDialog(this,"Save S-Expression",FileDialog.SAVE);
    fd.setDirectory("c:\\sdsi\\"); //don't want this in final version
    fd.setVisible(true);
    String file = fd.getDirectory() + fd.getFile();
    if (file == null)
      return;
    try {
      FileOutputStream fos = new FileOutputStream(file);
      ObjectOutputStream oos = new ObjectOutputStream(fos);
      oos.writeObject(cache);
      fos.close();
      status.setText("Cache saved");
    }
    catch (Exception e) {
      new ErrorDialog(this,"I/O Error",e.getMessage()).setVisible(true);
    }
	}

	void loadCache_Action(java.awt.event.ActionEvent event)
	{
		FileDialog fd = new FileDialog(this,"Read in S-Expressions",FileDialog.LOAD);
    fd.setDirectory("c:\\sdsi\\"); //don't want this in final version
    fd.setVisible(true);
    String file = fd.getDirectory() + fd.getFile();
    if (file == null)
      return;
    try {
      FileInputStream fis = new FileInputStream(file);
      ObjectInputStream ois = new ObjectInputStream(fis);
      cache = (CertCache)ois.readObject();
      fis.close();
      verifier = new Verification(cache);
      status.setText("Cache loaded");
    }
    catch (Exception e) {
      new ErrorDialog(this,"I/O Error",e.getMessage()).setVisible(true);
    }
	}

	void createObjectMenuItem_Action(java.awt.event.ActionEvent event)
	{
		cards.show(controls,SDSIOBJECTS);
	}
}



